diff --git a/modules/features/chatbot/mainChatbot.py b/modules/features/chatbot/mainChatbot.py
index 8bcc73ce..1428ef41 100644
--- a/modules/features/chatbot/mainChatbot.py
+++ b/modules/features/chatbot/mainChatbot.py
@@ -1000,218 +727,215 @@ Return ONLY valid JSON, no other text."""
                     researchDepth="general",
                     operationId=None
                 )
-                # Extract text from research result
-                if isinstance(researchResult, dict):
-                    webResearchResults = json.dumps(researchResult, ensure_ascii=False, indent=2)
-                else:
-                    webResearchResults = str(researchResult)
-                logger.info("Web research completed successfully")
-                
-                await event_manager.emit_event(
-                    workflowId,
-                    "progress",
-                    "Internet-Recherche abgeschlossen",
-                    "web_research"
-                )
+                webResearchResults = json.dumps(researchResult, ensure_ascii=False, indent=2) if isinstance(researchResult, dict) else str(researchResult)
             except Exception as e:
                 logger.error(f"Web research failed: {e}")
                 webResearchResults = f"Web research error: {str(e)}"
-                
-                await event_manager.emit_event(
-                    workflowId,
-                    "error",
-                    f"Fehler bei Internet-Recherche: {str(e)}",
-                    "web_research"
-                )
         
-        # Check if workflow was stopped before answer generation
         if await _check_workflow_status(interfaceDbChat, workflowId, event_manager):
             return
         
-        # Step 4: Generate final answer
-        logger.info("Step 4: Generating final answer from all query results...")
-        
-        await event_manager.emit_event(
-            workflowId,
-            "status",
-            "Formuliere finale Antwort mit allen Ergebnissen...",
-            "answer_generation"
-        )
-        
-        # Build context for final answer with all query results
+        # Build answer context
         answerContext = f"User question: {userInput.prompt}{context}\n\n"
-        
         if queryResults:
-            answerContext += "Database query results (all queries executed in parallel):\n\n"
-            for query_key, result in queryResults.items():
-                if query_key != "error":
-                    answerContext += f"{query_key} results:\n{result}\n\n"
-            if "error" in queryResults:
-                answerContext += f"Errors: {queryResults['error']}\n\n"
-        
+            for key, result in queryResults.items():
+                if key != "error":
+                    answerContext += f"Database results:\n{result}\n\n"
         if webResearchResults:
-            answerContext += f"Web research results:\n{webResearchResults}\n\n"
+            answerContext += f"Web research:\n{webResearchResults}\n\n"
+        
+        # Step 3: Process Excel File
+        excel_error = None
+        if needsExcelFile:
+            logger.info(f"Step 3: Processing Excel file (action: {excelAction})...")
+            await event_manager.emit_event(
+                workflowId,
+                "status",
+                f"Erstelle Excel-Datei..." if excelAction == "create" else "Aktualisiere Excel-Datei...",
+                "excel_processing"
+            )
+            
+            try:
+                # Check if we have query data for updates
+                if excelAction == "update":
+                    if not queryData or "main" not in queryData or not queryData["main"]:
+                        error_msg = f"No query data available for Excel update. queryData keys: {list(queryData.keys()) if queryData else 'None'}"
+                        if queryResults.get("error"):
+                            error_msg += f" Query error: {queryResults['error']}"
+                        logger.error(error_msg)
+                        excel_error = f"Die Datenbankabfrage ist fehlgeschlagen: {queryResults.get('error', 'Unbekannter Fehler')}. Die Excel-Datei konnte nicht aktualisiert werden."
+                        raise ValueError(excel_error)
+                
+                workflow = interfaceDbChat.getWorkflow(workflowId)
+                if workflow:
+                    services.workflow = workflow
+                
+                method_ai = MethodAi(services)
+                
+                # Prepare document references for updates
+                if excelAction == "update" and userInput.listFileId:
+                    if not document_references or not document_references.references:
+                        document_references = await _convert_file_ids_to_document_references(services, userInput.listFileId)
+                else:
+                    from modules.datamodels.datamodelDocref import DocumentReferenceList
+                    document_references = DocumentReferenceList(references=[])
+                
+                # Build Excel prompt
+                if excelAction == "update":
+                    # Format query data as JSON lookup table
+                    lookup_table_json = _format_query_results_as_lookup(queryData)
+                    lookup_table_dict = json.loads(lookup_table_json)
+                    logger.info(f"Generated lookup table with {len(lookup_table_dict)} entries")
+                    
+                    # Log sample entries for debugging
+                    if lookup_table_dict:
+                        sample_keys = list(lookup_table_dict.keys())[:3]
+                        logger.info(f"Sample Artikelnummern in lookup table: {sample_keys}")
+                        if sample_keys:
+                            sample_entry = lookup_table_dict[sample_keys[0]]
+                            logger.info(f"Sample entry for '{sample_keys[0]}': {list(sample_entry.keys())}")
+                            logger.info(f"Sample entry values: {sample_entry}")
+                    
+                    # Determine columns to add
+                    column_names = requested_columns if requested_columns else []
+                    if not column_names:
+                        prompt_lower = userInput.prompt.lower()
+                        if "einkaufspreis" in prompt_lower or "purchase price" in prompt_lower or "kaufpreis" in prompt_lower:
+                            column_names = ["Einkaufspreis"]
+                        elif "lieferant" in prompt_lower or "supplier" in prompt_lower:
+                            column_names = ["Lieferant"]
+                        elif "lagerbestand" in prompt_lower or "stock" in prompt_lower:
+                            column_names = ["Lagerbestand"]
+                        else:
+                            # Default: try to infer from available columns in lookup table
+                            if lookup_table_dict:
+                                sample_entry = next(iter(lookup_table_dict.values()))
+                                available_columns = list(sample_entry.keys())
+                                logger.info(f"Available columns in lookup table: {available_columns}")
+                                # Prefer common columns
+                                if "Einkaufspreis" in available_columns:
+                                    column_names = ["Einkaufspreis"]
+                                elif "Lieferant" in available_columns:
+                                    column_names = ["Lieferant"]
+                                else:
+                                    column_names = available_columns[:1] if available_columns else ["Lieferant"]
+                            else:
+                                column_names = ["Lieferant"]
+                    
+                    logger.info(f"Adding columns to Excel: {column_names}")
+                    column_name_str = ", ".join(column_names)
+                    
+                    # Build a more explicit prompt with clear instructions and the lookup table
+                    # Include the lookup table data directly in the prompt so it's always available
+                    excel_prompt = f"""You are updating an Excel file. CRITICAL TASK:
+
+Add new column(s) "{column_name_str}" to the attached Excel file by matching Artikelnummer values.
+
+STEP-BY-STEP PROCESS (MUST FOLLOW EXACTLY):
+1. Read the attached Excel file completely - all sheets, all rows, all columns.
+2. Find the column containing "Artikelnummer" (may be named "Artikelnummer", "Artikel Nummer", "Art-Nr", "Artikelnummer", etc.)
+3. For EACH ROW in the Excel file:
+   a. Read the Artikelnummer value from that row (e.g., "LED001", "12345", etc.)
+   b. Look up that EXACT Artikelnummer in the DATABASE LOOKUP TABLE below (case-sensitive match)
+   c. If the Artikelnummer is found in the lookup table:
+      - Extract the value(s) for column(s) "{column_name_str}" from the matching entry
+      - Write the value(s) to the new column(s) in that row
+   d. If the Artikelnummer is NOT found in the lookup table:
+      - Leave the new column(s) empty for that row
+4. Preserve ALL existing data, formatting, formulas, and structure exactly as-is.
+5. Return ONLY the complete modified Excel file (.xlsx format). Do NOT include any text or explanations.
+
+=== DATABASE LOOKUP TABLE (JSON) ===
+Use this table to match Artikelnummer and extract values. Format: {{"Artikelnummer": {{"column": "value", ...}}}}
+
+{lookup_table_json}
+
+=== EXAMPLE MATCHING ===
+- Excel row has Artikelnummer "LED001" in column "Artikelnummer"
+- Search for "LED001" in the lookup table above
+- Find entry: {{"LED001": {{"Lieferant": "Phoenix Contact", "Einkaufspreis": 12.50, ...}}}}
+- Extract "{column_name_str}" value from that entry
+- Write the extracted value to the new "{column_name_str}" column in that Excel row
+
+CRITICAL REQUIREMENTS:
+- Match EXACTLY by Artikelnummer (case-sensitive, exact string match)
+- Preserve ALL existing columns, rows, formatting, and formulas
+- Only add the new column(s), do NOT modify existing data
+- Return ONLY the Excel file binary data, no explanations"""
+                else:
+                    excel_prompt = f"""Create Excel file (.xlsx) from database results:
+
+{answerContext if queryResults else "No database results available."}
+
+User request: {userInput.prompt}
+
+Create well-structured spreadsheet with appropriate headers and formatting."""
+                
+                # Use simpleMode=True for Excel updates to ensure lookup table is directly accessible
+                # simpleMode=False goes through complex document generation pipeline which may lose context
+                excel_result = await method_ai.process({
+                    "aiPrompt": excel_prompt,
+                    "documentList": document_references if excelAction == "update" else None,
+                    "resultType": "xlsx",
+                    "simpleMode": True  # Use simple mode for direct Excel updates with lookup table
+                })
+                
+                if excel_result.success and excel_result.documents:
+                    for action_doc in excel_result.documents:
+                        try:
+                            chat_doc = await _create_chat_document_from_action_document(
+                                services, action_doc, "", workflowId, workflow.currentRound
+                            )
+                            if chat_doc:
+                                excel_documents.append(chat_doc)
+                        except Exception as e:
+                            logger.error(f"Error creating ChatDocument: {e}", exc_info=True)
+                    logger.info(f"Excel processing complete: {len(excel_documents)} documents")
+                else:
+                    excel_error = f"Excel-Verarbeitung fehlgeschlagen: {excel_result.error if excel_result else 'Unbekannter Fehler'}"
+                    logger.warning(excel_error)
+            except Exception as e:
+                excel_error = str(e) if not excel_error else excel_error
+                logger.error(f"Error processing Excel: {e}", exc_info=True)
+        
+        if await _check_workflow_status(interfaceDbChat, workflowId, event_manager):
+            return
+        
+        # Step 4: Generate Final Answer
+        logger.info("Step 4: Generating final answer...")
+        await event_manager.emit_event(workflowId, "status", "Formuliere finale Antwort...", "answer_generation")
+        
+        excel_context = ""
+        if needsExcelFile:
+            if excel_documents:
+                file_names = [doc.fileName for doc in excel_documents]
+                action_text = "erstellt" if excelAction == "create" else "aktualisiert"
+                file_name_str = file_names[0] if len(file_names) == 1 else f"{len(file_names)} Dateien"
+                excel_context = f"\n\nWICHTIG - EXCEL-DATEI {action_text.upper()}:\nDie Excel-Datei '{file_name_str}' wurde erfolgreich {action_text} und ist als Anhang verfügbar. Erwähne dies am Ende deiner Antwort."
+            elif excel_error:
+                excel_context = f"\n\nFEHLER - EXCEL-VERARBEITUNG:\n{excel_error}\nErkläre dem Nutzer, warum die Excel-Datei nicht aktualisiert werden konnte."
+        
+        # Build answer context parts (avoid backslashes in f-string expressions)
+        db_results_part = f"\nDATENBANK-ERGEBNISSE:\n{answerContext}" if queryResults and not queryResults.get("error") else ""
+        if queryResults.get("error"):
+            db_results_part = f"\nDATENBANK-FEHLER:\n{queryResults['error']}"
+        web_results_part = f"\nINTERNET-RECHERCHE:\n{webResearchResults}" if webResearchResults else ""
         
         answerPrompt = f"""Heute ist der {current_date}.
 
-Du bist ein Chatbot der Althaus AG.
-Du hast Zugriff auf ein SQL query tool, dass es dir ermöglicht, SQL SELECT Abfragen auf der Althaus AG Datenbank auszuführen.
+Du bist ein Chatbot der Althaus AG. Antworte auf Deutsch (kein ß, immer ss).
 
-KRITISCH - AUSFÜHRLICHE ANTWORTEN ERFORDERLICH:
-Du MUSST immer sehr ausführliche, detaillierte und strukturierte Antworten geben. Einfache, kurze Antworten sind NICHT ausreichend!
-
-ANTWORT-STRUKTUR FÜR DATENBANK-ABFRAGEN:
-Wenn du Datenbank-Ergebnisse präsentierst, MUSS deine Antwort folgende Struktur haben:
-
-1. EINLEITUNG MIT QUELLENANGABE:
-   - Beginne IMMER mit: "Aus der Datenbank habe ich eine umfassende Analyse [des Themas] durchgeführt:"
-   - Oder: "Aus der Datenbank habe ich folgende Informationen gefunden:"
-
-2. ÜBERSCHRIFT MIT THEMA:
-   - Gib eine klare Überschrift, z.B. "LED-Lagerbestand Übersicht" oder "Artikel-Übersicht: [Suchbegriff]"
-
-3. ZUSAMMENFASSUNG MIT STATISTIKEN:
-   - Gib IMMER eine detaillierte Zusammenfassung mit wichtigen Kennzahlen
-   - Beispiele:
-     * "Gesamtbestand LEDs: 7'411 Stück verteilt auf 157 verschiedene Artikel"
-     * "1'027 LED-Artikel insgesamt in der Datenbank"
-     * "157 Artikel haben aktuell Lagerbestand > 0"
-     * "273 Artikel ohne Lagerinformationen"
-   - Formatiere Zahlen mit Tausender-Trennzeichen (z.B. 7'411 statt 7411)
-   - Verwende Aufzählungen für bessere Lesbarkeit
-
-4. TOP-LIEFERANTEN TABELLE (wenn relevant):
-   - Wenn mehrere Lieferanten vorhanden sind, erstelle IMMER eine Tabelle mit Top-Lieferanten
-   - Spalten: Lieferant, Anzahl Artikel, Gesamtbestand (oder andere relevante Metriken)
-   - Sortiere nach Gesamtbestand oder Anzahl Artikel (absteigend)
-   - Zeige mindestens Top 10 Lieferanten
-
-5. TOP-ARTIKEL TABELLE:
-   - Erstelle IMMER eine Tabelle mit den Top 20 Artikeln
-   - Spalten sollten enthalten: Artikelnummer (als Link), Artikelbezeichnung, Lieferant, Lagerplatz, Ist-Bestand, Soll-Bestand (wenn verfügbar)
-   - Sortiere nach Ist-Bestand (absteigend) oder nach Relevanz
-   - Formatiere Zahlen mit Tausender-Trennzeichen
-
-6. ZUSÄTZLICHE ANALYSEN:
-   - Füge immer eine kurze Analyse hinzu, z.B.:
-     * "Phoenix Contact AG dominiert klar mit über 68% des gesamten LED-Lagerbestands"
-     * "Die meisten Artikel sind Beschriftungsmarker und -schilder"
-   - Erkläre interessante Muster oder Auffälligkeiten
-
-7. HINWEIS BEI MEHR ERGEBNISSEN:
-   - Wenn mehr als 20 Artikel existieren, füge IMMER hinzu:
-     * "_Es existieren weitere X Artikel. Die Tabelle zeigt die 20 Artikel mit dem höchsten Bestand._"
-   - Oder: "_Es wurden insgesamt X Artikel gefunden. Die Tabelle zeigt die ersten 20._"
-
-8. NÄCHSTE SCHRITTE - MEHRERE VORSCHLÄGE:
-   - Gib IMMER mindestens 5 verschiedene Vorschläge für nächste Schritte
-   - Formatiere als Aufzählung mit Bullet Points
-   - Beispiele:
-     * "Details zu einem bestimmten LED-Artikel erfahren?"
-     * "LED-Artikel mit niedrigem Lagerbestand oder unter Mindestbestand anzeigen?"
-     * "Nach spezifischen LED-Typen suchen (z.B. Signalleuchten, Anzeige-LEDs, LED-Strips)?"
-     * "Preisinformationen zu den LED-Artikeln abrufen?"
-     * "LED-Artikel eines bestimmten Lieferanten detailliert anzeigen?"
-   - Passe die Vorschläge an den Kontext an
-
-TABELLEN-FORMATIERUNG:
-- Verwende IMMER Markdown-Tabellen für strukturierte Daten
-- Spalten sollten klar getrennt sein mit | 
-- Header-Zeile sollte deutlich hervorgehoben sein
-- Zahlen sollten rechtsbündig sein (in Markdown mit Leerzeichen)
-- Verwende Tausender-Trennzeichen (z.B. 1'090 statt 1090)
-
-QUELLENANGABE - DATENBANK:
-WICHTIG: Wenn du Informationen aus der Datenbank präsentierst, kennzeichne dies IMMER klar für den Nutzer.
-- Beginne deine Antwort mit einer klaren Kennzeichnung, z.B.: "Aus der Datenbank habe ich eine umfassende Analyse durchgeführt:"
-- Bei kombinierten Informationen (Datenbank + Internet): Trenne klar zwischen beiden Quellen
-
-QUELLENANGABE - INTERNET:
-WICHTIG: Wenn du Informationen aus dem Internet präsentierst, kennzeichne dies IMMER klar für den Nutzer.
-- Beginne Internet-Recherchen mit: "Aus meiner Internet-Recherche:" oder "Laut Online-Quellen:"
-- Gib IMMER die konkreten Quellen an (Website-Namen und Links)
-- Bei mehreren Quellen: Liste die Quellen auf und verweise darauf
-- Trenne klar zwischen Datenbank-Informationen und Internet-Recherchen
-
-TABELLENLÄNGE UND ARTIKELANZAHL - KRITISCH:
-WICHTIG: Zeige MAXIMAL 20 Artikel in Tabellen. Du darfst und sollst aber ausführliche Erklärungen liefern!
-
-ZAHLEN-PRÜFUNG - ABSOLUT KRITISCH:
-BEVOR du deine finale Antwort zurückgibst, MUSST du diese Schritte befolgen:
-1. ZÄHLE die TATSÄCHLICHEN Zeilen in deiner finalen Tabelle
-2. Diese Zahl ist die EINZIGE korrekte Anzahl für deine Antwort
-3. Verwende diese Zahl KONSISTENT überall in deiner Antwort
-4. Formatiere Zahlen mit Tausender-Trennzeichen (z.B. 7'411 statt 7411)
-
-Wenn immer du eine Artikelnummer innerhalb einer Tabelle zurückgibst bitte markiere diese als Markdownlink:
-[ARTIKELNUMMER](/details/ARTIKELNUMMER). ARTIKELNUMMER ist hierbei der Platzhalter, den du ersetzen musst.
-WICHTIG! Du musst im Link die ARTIKELNUMMER sicher URL-encodieren. Encodiere aber NICHT die Artikelnummer in eckigen Klammern. Also encodiere den Ankertext nicht!
-Ausserhalb einer Tabelle musst du keine Links auf Artikelnummern setzen.
-
-Du antwortest ausschliesslich auf Deutsch. Nutze kein sz(ß) sondern immer ss.
-
-STREAMING-UPDATES:
-Während du die Antwort erstellst, denke daran, dass der Nutzer Updates erhalten sollte:
-- "Kompliliere Statistiken..."
-- "Erstelle Lieferanten-Tabelle..."
-- "Formatiere Top-20-Artikel..."
-- "Formuliere finale Antwort mit übersichtlicher Tabelle..."
-- "Füge zusätzliche Analysen hinzu..."
-
-Sende diese Updates sehr häufig, damit der Nutzer weiss, was du gerade machst. Es ist ganz wichtig, dass du den Nutzer so oft es geht auf dem Laufenden hältst.
-Die Beispiele oben sind nur Beispiele. Wenn möglich, sei spezifischer und kreativer, damit der Nutzer genau weiss, was du gerade tust.
-Falls es möglich ist, gib in den Status-Updates auch schon Zwischenergebnisse an, z.B. "Habe 20 Artikel gefunden, suche weiter nach ähnlichen Begriffen".
-Du kannst auch gerne deinen Denkenprozess in den Status-Updates beschreiben, z.B. "Überlege, welche Suchbegriffe ich noch verwenden könnte".
-Es ist super wichtig, dass wir dem Nutzer laufend Updates geben, damit er nicht das Gefühl hat, dass er zu lange warten muss.
-Wichtig: Sende auch eine Status-Update, wenn du die Zusammenfassende Antwort an den Nutzer schreibst, z.B. "Formuliere finale Antwort mit übersichtlicher Tabelle..".
-
-Answer the user's question in German: {userInput.prompt}{context}
-
-{answerContext}
-
-KRITISCH: Du hast jetzt ZUSÄTZLICHE Datenbankabfragen erhalten, die dir detaillierte Informationen liefern:
-- "Total count query results" - Gesamtanzahl der Artikel
-- "Top suppliers query results" - Top-Lieferanten mit Artikelanzahl und Gesamtbestand
-- "Top 20 articles query results" - Top 20 Artikel mit allen Details
-
-VERWENDE ALLE DIESE DATEN für deine Antwort! Erstelle eine umfassende Antwort mit:
-
-1. EINLEITUNG: "Aus der Datenbank habe ich eine umfassende Analyse [des Themas] durchgeführt:"
-
-2. ÜBERSCHRIFT: z.B. "LED-Lagerbestand Übersicht"
-
-3. ZUSAMMENFASSUNG MIT STATISTIKEN:
-   - Verwende die Daten aus "Total count query results" für Gesamtanzahl
-   - Verwende die Daten aus "Initial database query results" für Gesamtbestand
-   - Berechne weitere Kennzahlen basierend auf den Daten
-
-4. TOP-LIEFERANTEN TABELLE:
-   - Verwende IMMER die Daten aus "Top suppliers query results"
-   - Erstelle eine Tabelle mit: Lieferant | Anzahl Artikel | Gesamtbestand
-   - Sortiere nach Gesamtbestand (absteigend)
-   - Zeige mindestens Top 10
-
-5. TOP 20 ARTIKEL TABELLE:
-   - Verwende IMMER die Daten aus "Top 20 articles query results"
-   - Erstelle eine Tabelle mit: Artikelnummer (als Link) | Artikelbezeichnung | Lieferant | Lagerplatz | Ist-Bestand | Soll-Bestand
-   - Formatiere Zahlen mit Tausender-Trennzeichen
-
-6. ZUSÄTZLICHE ANALYSEN:
-   - Analysiere die Daten und gib interessante Erkenntnisse
-   - z.B. "Phoenix Contact AG dominiert klar mit über 68% des gesamten Lagerbestands"
-
-7. HINWEIS BEI MEHR ERGEBNISSEN:
-   - Wenn mehr als 20 Artikel existieren: "_Es existieren weitere X Artikel. Die Tabelle zeigt die 20 Artikel mit dem höchsten Bestand._"
-
-8. NÄCHSTE SCHRITTE:
-   - Gib mindestens 5 verschiedene Vorschläge als Aufzählung
-
-WICHTIG: 
-- Verwende ALLE verfügbaren Daten aus den zusätzlichen Abfragen
-- Erstelle Tabellen aus den Daten - nicht nur Text!
-- Formatiere Zahlen mit Tausender-Trennzeichen (z.B. 7'411 statt 7411)
-- Sei sehr ausführlich und detailliert - kurze Antworten sind NICHT ausreichend!"""
+Antworte auf: {userInput.prompt}{context}
+{db_results_part}{web_results_part}{excel_context}
 
+WICHTIG:
+- Klare, strukturierte Antwort
+- Zahlen mit Tausender-Trennzeichen (7'411)
+- Markdown-Tabellen für Daten (max 20 Zeilen)
+- Artikelnummern als Link: [ARTIKELNUMMER](/details/ARTIKELNUMMER)
+- Wenn Excel-Datei erstellt wurde, bestätige dies explizit am Ende
+- Wenn Excel-Verarbeitung fehlgeschlagen ist, erkläre dem Nutzer den Fehler klar"""
+        
         answerRequest = AiCallRequest(
             prompt=answerPrompt,
             context=answerContext if (queryResults or webResearchResults) else None,
@@ -1225,24 +949,8 @@ WICHTIG:
         answerResponse = await services.ai.callAi(answerRequest)
         finalAnswer = answerResponse.content
         
-        logger.info("Final answer generated successfully")
+        logger.info("Final answer generated")
         
-        # Store log: Answer generation completed
-        services.chat.storeLog(workflow, {
-            "message": "Antwort erfolgreich generiert",
-            "type": "info",
-            "status": "running",
-            "progress": 0.9
-        })
-        
-        await event_manager.emit_event(
-            workflowId,
-            "progress",
-            "Antwort erfolgreich generiert",
-            "answer_generation"
-        )
-        
-        # Check if workflow was stopped after answer generation
         if await _check_workflow_status(interfaceDbChat, workflowId, event_manager):
             return
         
@@ -1250,8 +958,10 @@ WICHTIG:
         # Reload workflow to get updated message count
         workflow = interfaceDbChat.getWorkflow(workflowId)
         
+        # Prepare message data with Excel documents if any
+        message_id = f"msg_{uuid.uuid4()}"
         assistantMessageData = {
-            "id": f"msg_{uuid.uuid4()}",
+            "id": message_id,
             "workflowId": workflowId,
             "parentMessageId": userMessageId,
             "message": finalAnswer,
@@ -1264,6 +974,22 @@ WICHTIG:
             "taskNumber": 0,
             "actionNumber": 0
         }
+        
+        # Add Excel documents if any were created
+        if excel_documents:
+            # Update messageId in all Excel documents
+            for excel_doc in excel_documents:
+                excel_doc.messageId = message_id
+            
+            # Convert ChatDocuments to dict format
+            try:
+                documents_dict = [doc.model_dump() for doc in excel_documents]
+            except Exception:
+                documents_dict = [doc.dict() for doc in excel_documents]
+            
+            assistantMessageData["documents"] = documents_dict
+            assistantMessageData["documentsLabel"] = "Excel Files"
+        
         assistantMessage = interfaceDbChat.createMessage(assistantMessageData)
         logger.info(f"Stored assistant message: {assistantMessage.id}")
         
diff --git a/modules/interfaces/interfaceDbChatObjects.py b/modules/interfaces/interfaceDbChatObjects.py
index 04bde515..40e30eaa 100644
--- a/modules/interfaces/interfaceDbChatObjects.py
+++ b/modules/interfaces/interfaceDbChatObjects.py
@@ -1004,24 +1004,36 @@ class ChatObjects:
             
             # Create documents in normalized documents table
             created_documents = []
-            for doc_data in documents_to_create:
-                # Normalize to plain dict before assignment
-                if isinstance(doc_data, ChatDocument):
-                    doc_dict = doc_data.model_dump()
-                elif isinstance(doc_data, dict):
-                    doc_dict = dict(doc_data)
-                else:
-                    # Attempt to coerce to ChatDocument then dump
-                    try:
-                        doc_dict = ChatDocument(**doc_data).model_dump()
-                    except Exception:
-                        logger.error("Invalid document data type for message creation")
-                        continue
-                
-                doc_dict["messageId"] = createdMessage["id"]
-                created_doc = self.createDocument(doc_dict)
-                if created_doc:
-                    created_documents.append(created_doc)
+            logger.debug(f"Creating {len(documents_to_create)} document(s) for message {createdMessage['id']}")
+            for idx, doc_data in enumerate(documents_to_create):
+                try:
+                    # Normalize to plain dict before assignment
+                    if isinstance(doc_data, ChatDocument):
+                        doc_dict = doc_data.model_dump()
+                    elif isinstance(doc_data, dict):
+                        doc_dict = dict(doc_data)
+                    else:
+                        # Attempt to coerce to ChatDocument then dump
+                        try:
+                            doc_dict = ChatDocument(**doc_data).model_dump()
+                        except Exception as e:
+                            logger.error(f"Invalid document data type for message creation (document {idx + 1}/{len(documents_to_create)}): {e}")
+                            continue
+                    
+                    # Ensure messageId is set
+                    doc_dict["messageId"] = createdMessage["id"]
+                    logger.debug(f"Creating document {idx + 1}/{len(documents_to_create)}: fileName={doc_dict.get('fileName', 'unknown')}, fileId={doc_dict.get('fileId', 'unknown')}, messageId={doc_dict.get('messageId', 'unknown')}")
+                    
+                    created_doc = self.createDocument(doc_dict)
+                    if created_doc:
+                        created_documents.append(created_doc)
+                        logger.debug(f"Successfully created document {idx + 1}/{len(documents_to_create)}: {created_doc.fileName} (id: {created_doc.id})")
+                    else:
+                        logger.error(f"Failed to create document {idx + 1}/{len(documents_to_create)}: createDocument returned None for fileName={doc_dict.get('fileName', 'unknown')}")
+                except Exception as e:
+                    logger.error(f"Error processing document {idx + 1}/{len(documents_to_create)}: {e}", exc_info=True)
+            
+            logger.info(f"Created {len(created_documents)}/{len(documents_to_create)} document(s) for message {createdMessage['id']}")
             
             # Convert to ChatMessage model
             chat_message = ChatMessage(
@@ -1256,12 +1268,18 @@ class ChatObjects:
         try:
             # Validate and normalize document data to dict
             document = ChatDocument(**documentData)
+            logger.debug(f"Creating document in database: fileName={document.fileName}, fileId={document.fileId}, messageId={document.messageId}")
             created = self.db.recordCreate(ChatDocument, document.model_dump())
             
-            
-            return ChatDocument(**created)
+            if created:
+                created_doc = ChatDocument(**created)
+                logger.debug(f"Successfully created document in database: {created_doc.fileName} (id: {created_doc.id})")
+                return created_doc
+            else:
+                logger.error(f"Failed to create document in database: recordCreate returned None for fileName={document.fileName}")
+                return None
         except Exception as e:
-            logger.error(f"Error creating message document: {str(e)}")
+            logger.error(f"Error creating message document: {str(e)}", exc_info=True)
             return None
 
 
